#pragma once

#include "eopcc/cloud.hpp"
#include "eopcc/io.hpp"

namespace eopcc {

class TXTReader : public PointCloudReader {
public:
	TXTReader(const std::string& filename);
	virtual PointCloud ReadSubCloud(int sub_cloud_size);
	virtual size_t NumRemainingPoints() { return num_points_remaining_; }
	virtual PointCloud GetSeedCloud() {
		return seed_cloud_;
	}
private:
	std::ifstream infile_;
	size_t num_points_remaining_;
	PointCloud seed_cloud_;
};

class TXTWriter : public PointCloudWriter {
public:
	TXTWriter(const std::string& filename);
	virtual ~TXTWriter();
	virtual void WriteSubCloud(const PointCloud& sub_cloud);
private:
	std::ofstream out_file_;
	size_t points_written_;
};


void LoadFromTXT(const std::string& txt_file_name, PointCloud& point_cloud);
void WriteToTXT(const std::string& txt_file_name, const PointCloud& point_cloud);

}
